QGIS Application - Bug report #1162
missing possibility to use QML Style for more than one layer
2008-07-17 12:21 AM - bjpfei -

Status: Closed

Priority: Low

Assignee: Jurgen Fischer

Category: Project Loading/Saving

Affected QGIS version: Regression?: No
Operating System: All Easy fix?: No
Pull Request or Patch supplied: Resolution: fixed
Crashes QGIS or corrupts data: Copied to github as #: 11222
Description

In the gml-File informations about datasource or layername are stored.
<datasource>dbname='bla' host=localhost port=123 user="test' table="zonenplan"."grundnutzung" (wkb_geometry)
sgl=</datasource>
<layername>grundnutzung</layername>

Furthermore the classificationfield is stored as column-number and not with the fieldname.
<classificationfield>13</classificationfield>

Thus at the moment it's not possible to use a QML-Style for more than one layer. If you use it with another layer QGIS renders nothing or
in some cases still crashes.

However | think the sense of a QML-Style is using it for more than one layer because for use with one layer we have the standard style.
So, are there any reasons for saving all these informations in the QML-Style?

Associated revisions

Revision 118b2158 - 2008-12-11 12:07 PM - Jiirgen Fischer

fix #1162

git-svn-id: http://svn.osgeo.org/qgis/trunk/qgis@9771 c8812cc2-4d05-0410-92ff-de0c093fc19¢c

Revision 56b5ba7e - 2008-12-11 12:07 PM - Jiirgen Fischer

fix #1162

git-svn-id: http://svn.osgeo.org/qgis/trunk@9771 c8812cc2-4d05-0410-92ff-de0c093fc19¢c

History

#1 - 2008-08-20 07:26 AM - Maciej Sieczka -

| don't consider this issue as an enhacement request. It is a critical bug rather. If re-using QMLs for different layers is not supported, QGIS should

explicitely prevent it. Otherwise user's project becomes corrupted. E.g.:

1. Set up symbology for a shapefile.
2. Save the style for this shapefile.

3. Load it for another Shapefile.

The 'another' shapefile is now replaced by the Shapefile for which the symbology was set-up for in 1. A couple of weird, random issues begin to crop out -

can't remove some layers in the project, saving and reloading the project sometimes make some layers dissapear etc.

#2 - 2008-08-31 12:56 PM - Tim Sutton

Can you confirm if this bug is still an issue using svn trunk? For me it works fine in svn trunk.

Regarding the field number instead of field name issue, you should file a separate bug for that since its a 'feature’ of how layer properties are serialised -
gml files make use of the standard QGIS serialisation routines to do their thing.

Regards

Tim

#3 - 2008-09-01 01:53 AM - Horst Diister

Replying to [comment:2 timlinux]:

Can you confirm if this bug is still an issue using svn trunk? For me it works fine in svn trunk.

Regarding the field number instead of field name issue, you should file a separate bug for that since its a 'feature' of how layer properties are
serialised - gml files make use of the standard QGIS serialisation routines to do their thing.

Regards

Tim

The fix looks to be half done.

1. Load a polygon layer with community borders.

2. Create and save a unique values style QML based on community names.

3. Load an other layer containing an attribute community names.

4. Load the prior defined QML to the new layer.

5. The legend name of the new layer is changed to the name of the first layer.

6. Classification in map canvas is performed correctly but the legend is not updated.

7. Toggle the visibility of the new layer off and on, the layer disappears from map canvas.

What could be a way to handle this issue? Perhaps a solution could be as follows:

When | load a QML Style to a layer QGIS have to check whether this QML is associated to the layer or not. This information is known from the connection
parameters. If the layer is not associated don't change the layer name and ask the user to choose an appropriate attribute of the given attributes. The user

is responsible for the correctness of the choosen attribute. Maybe this could be an appropriate approach?

#4 - 2008-09-01 08:07 PM - Ollie O'Brien -

Replying to [comment:3 hdus]:

Replying to [comment:2 timlinux]:

Can you confirm if this bug is still an issue using svn trunk? For me it works fine in svn trunk.

Regarding the field number instead of field name issue, you should file a separate bug for that since its a 'feature' of how layer properties are
serialised - gml files make use of the standard QGIS serialisation routines to do their thing.

Regards

Tim

The fix looks to be half done.

1. Load a polygon layer with community borders.

| 2. Create and save a unique values style QML based on community names.
| 3. Load an other layer containing an attribute community names.

| 4. Load the prior defined QML to the new layer.

| 5. The legend name of the new layer is changed to the name of the first layer.

| 6. Classification in map canvas is performed correctly but the legend is not updated.

7. Toggle the visibility of the new layer off and on, the layer disappears from map canvas.

What could be a way to handle this issue? Perhaps a solution could be as follows:

When | load a QML Style to a layer QGIS have to check whether this QML is associated to the layer or not. This information is known from the
connection parameters. If the layer is not associated don't change the layer name and ask the user to choose an appropriate attribute of the given
attributes. The user is responsible for the correctness of the choosen attribute. Maybe this could be an appropriate approach?

Just to add a "Me too", | can confirm that this is indeed the case - applying a QML style file to a different layer does now work - but as soon as the layer (or
any other layer) is toggled off/on, all the layers using QML style files that weren't originally created for them disappear from the canvas, apparently

permanently.
In point 5, | think the reason for this is that the display name (for the legend) defaults to the layer name and this gets saved down with the QML style file

creation - so gets reapplied to a different layer. This feels to me like "functioning as intended" - | would actually want the layer name to be picked up from

the QML, for my legend.

#5 - 2008-09-01 08:09 PM - Ollie O'Brien -

On point 7 - the layers concerned (those with QML files from other layers) also disappear if a new (unrelated) layer is added to the canvas.

#6 - 2008-10-06 06:50 AM - Tim Sutton

- Status changed from Open to Closed
- Resolution set to fixed

This issue is fixed at QGIS code sprint Warmwaterberg just near Ronnies Sexshop ;-) coords 20.900,-33.765 by Tim, Marco (really mostly), Horst and Till.
(Mission completed) Fixed with commit:b4937cb8 (SVN r9439)

#7 - 2008-12-06 01:42 PM - Jiirgen Fischer
- Status changed from Closed to Feedback
- Resolution deleted (fixed)

the bugfix drops everything except the renderer information from the gml.

#8 - 2008-12-06 01:42 PM - Jiirgen Fischer

- Status changed from Feedback to Open

#9 - 2008-12-06 07:11 PM - Jiirgen Fischer

- Resolution set to fixed
- Status changed from Open to Closed

fixed in commit:270fe71f (SVN r9748)

#10 - 2008-12-11 01:20 AM - Horst Diister
- Status changed from Closed to Feedback
- Resolution deleted (fixed)

It seems that the fix leeds to problems of reloading a project file.

1. Issue: | load a vector layer via Python plugin from [[PostGIS]] without QML symbology. The layer is loaded correct. Save project and reload project,

QGIS throws an error message: unable to load layer

2. Issue: | load a vector layer via [[PostGIS]] connector without QML symbology. The layer is loaded correct. Save project and reload project, QGIS

doesn't throw an error the layer is loaded but not displayed.

With commit:e7f90b4d (SVN r9747) all works fine, with commit:270fe71f (SVN r9748) the above mentined behaviour appears.
Loading shape works without problems.

#11 - 2008-12-11 03:08 AM - Jiirgen Fischer
- Status changed from Feedback to Closed
- Resolution set to fixed

fixed in commit:56b5ba7e (SVN r9772)

#12 - 2008-12-11 03:44 AM - Horst Diister

Jurgen, thank you very much for the fix

#13 - 2008-12-11 04:49 AM - Horst Diister
- Status changed from Closed to Feedback
- Resolution deleted (fixed)

mmm... now loading of shape layers is broken.

#14 - 2008-12-11 11:57 AM - Juirgen Fischer

Replying to [comment:13 hdus]:

mmm... now loading of shape layers is broken.

hm. seems fine to me. what's the problem?

#15 - 2008-12-12 03:38 AM - Horst Diister

Replying to [comment:14 jef]:

Replying to [comment:13 hdus]:

mmm... now loading of shape layers is broken.

hm. seems fine to me. what's the problem?

| just compiled commit:c861e6¢2 (SVN r9776) and all the problems of past commit:e7f90b4d (SVN r9747) still appears :-((

Now | get an additional problem. I'm not able to save QML-Files from [[PostGIS]] Layers via the "save style ..." button. QGIS Throws an error:

"Could not save symbology because:"

Thats all, no reason is mentioned. QML for Shape-Files are saveable without any problems.
| recompile commit:e7f90b4d (SVN r9747) and everything works fine.

My System:

Qt4.34

[[ReadHat]] AS4
[[PostgreSQL]] 8.3.3
[[PostGIS]] 1.3.3

#16 - 2008-12-12 06:38 AM - Jiirgen Fischer

Replying to [comment:15 hdus]:

1 just compiled commit:c861e6¢c2 (SVN r9776) and all the problems of past commit:e7f90b4d (SVN r9747) still appears :-((

Now | get an additional problem. I'm not able to save QML-Files from [[PostGIS]] Layers via the "save style ..." button. QGIS Throws an error:

"Could not save symbology because:"

Strange. | can't reproduce any of this.

#17 - 2008-12-15 05:18 AM - Jiirgen Fischer
- Resolution set to fixed
- Status changed from Feedback to Closed

fixed in

#18 - 2009-08-22 12:57 AM - Anonymous

Milestone Version 1.0.0 deleted

Files
bugfix_ticket1162.diff.oz2 9.93 KB 2008-10-06 Tim Sutton
